--  2002-10-07
with Resource_Strings; use Resource_Strings;
with X_Toolkit;        use X_Toolkit;
with Xm_Widgets.Manager.Bulletin_Board.Form;
use  Xm_Widgets.Manager.Bulletin_Board.Form;


package body Xm_Utilities.Form is

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Append_Set
   --!    <Implementation_Notes>
   ---------------------------------------------------------------------------
   procedure Append_Set (List       : in out Arg_List;
                         Name       : in     Xt_N_Resource_String;
                         Attachment : in     Attachment_Type;
                         W          : in     Widget) is
   begin
      if Attachment /= Attach_Widget
        and Attachment /= Attach_Opposite_Widget
      then
         raise Use_Error;
      end if;

      if Name = Xm_N_Top_Attachment then
         Append_Set (List, Xm_N_Top_Widget, W);
      elsif Name = Xm_N_Bottom_Attachment then
         Append_Set (List, Xm_N_Bottom_Widget, W);
      elsif Name = Xm_N_Left_Attachment then
         Append_Set (List, Xm_N_Left_Widget, W);
      elsif Name = Xm_N_Right_Attachment then
         Append_Set (List, Xm_N_Right_Widget, W);
      else
         raise Use_Error;
      end if;
      Append_Set (List, Name, Attachment);
   end Append_Set;


   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Append_Set
   --!    <Implementation_Notes>
   ---------------------------------------------------------------------------
   procedure Append_Set (List       : in out Arg_List;
                         Name       : in     Xt_N_Resource_String;
                         Attachment : in     Attachment_Type;
                         Position   : in     Integer) is
   begin
      if Attachment /= Attach_Position then
         raise Use_Error;
      end if;

      if Name = Xm_N_Top_Attachment then
         Append_Set (List, Xm_N_Top_Position, Position);
      elsif Name = Xm_N_Bottom_Attachment then
         Append_Set (List, Xm_N_Bottom_Position, Position);
      elsif Name = Xm_N_Left_Attachment then
         Append_Set (List, Xm_N_Left_Position, Position);
      elsif Name = Xm_N_Right_Attachment then
         Append_Set (List, Xm_N_Right_Position, Position);
      else
         raise Use_Error;
      end if;
      Append_Set (List, Name, Attachment);
   end Append_Set;

end Xm_Utilities.Form;
