--  2002-10-24
with X_Toolkit;                 use X_Toolkit;
with Xm_Widgets;                use Xm_Widgets;
with Xm_Widgets.Primitive.List; use Xm_Widgets.Primitive.List;


package body Xm_Utilities.List is


   procedure Format_List (Widgets      : in Widget_List_Type;
                          String_Table : in Xm_String_Table) is
      Argl           : Arg_List;
      Tab_List       : Xm_Tab_List;
      Render_Table   : Xm_Render_Table;
      Rendition_List : Xm_Rendition_Array (1 .. 1);
   begin
      Tab_List :=
        Xm_String_Table_Propose_Tablist
         (String_Table, Widgets (Widgets'First), Float (6.0), Relative);

      Argl := Null_Arg_List;
      Append_Get (Argl, Xm_N_Render_Table, Render_Table);
      Xt_Get_Values (Widgets (Widgets'First), Argl);

      Rendition_List (1) :=
        Xm_Render_Table_Get_Rendition (Render_Table, Motif_Default_Locale);

      Argl := Null_Arg_List;
      Append_Set (Argl, Xm_N_Tab_List, Tab_List);
      Xm_Rendition_Update (Rendition_List (1), Argl);

      Render_Table :=
        Xm_Render_Table_Add_Renditions
         (Xm_Render_Table_Copy (Render_Table, Null_Xm_String_Tag_Array),
          Rendition_List, Merge_Replace);

      Argl := Null_Arg_List;
      Append_Set (Argl, Xm_N_Render_Table, Render_Table);
      for I in Widgets'Range loop
         Xt_Set_Values (Widgets (I), Argl);
      end loop;

      Xm_Render_Table_Free (Render_Table);
      Xm_Rendition_Free (Rendition_List (1));
      Xm_Tab_List_Free (Tab_List);
   end Format_List;


end Xm_Utilities.List;
