--  2002-10-19
with X_Toolkit;  use X_Toolkit;
with Xm_Widgets; use Xm_Widgets;


package body Xm_Utilities.Xm_Strings is


   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Append
   --!    <Implementation_Notes>
   ---------------------------------------------------------------------------
   procedure Append (Source   : in out Xm_String;
                     New_Item : in     String) is
      Tmp : Xm_String;
   begin
      Tmp := Xm_String_Generate (New_Item);
      if Source = Null_Xm_String then
         Source := Tmp;
      else
         Source := Xm_String_Concat_And_Free (Source, Tmp);
      end if;
   end Append;


   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Append
   --!    <Implementation_Notes>
   ---------------------------------------------------------------------------
   procedure Append (Source   : in out Xm_String;
                     New_Item : in     Wide_String) is
      Tmp : Xm_String;
   begin
      Tmp := Xm_String_Generate (New_Item);
      if Source = Null_Xm_String then
         Source := Tmp;
      else
         Source := Xm_String_Concat_And_Free (Source, Tmp);
      end if;
   end Append;


   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Append_Separator
   --!    <Implementation_Notes>
   ---------------------------------------------------------------------------
   procedure Append_Separator (Source : in out Xm_String) is
      Tmp : Xm_String;
   begin
      Tmp :=
        Xm_String_Component_Create (Component_Separator, 0, Null_Xt_Pointer);
      if Source = Null_Xm_String then
         Source := Tmp;
      else
         Source := Xm_String_Concat_And_Free (Source, Tmp);
      end if;
   end Append_Separator;


   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Append_Tab
   --!    <Implementation_Notes>
   ---------------------------------------------------------------------------
   procedure Append_Tab (Source : in out Xm_String) is
      Tmp : Xm_String;
   begin
      Tmp := Xm_String_Component_Create (Component_Tab, 0, Null_Xt_Pointer);
      if Source = Null_Xm_String then
         Source := Tmp;
      else
         Source := Xm_String_Concat_And_Free (Source, Tmp);
      end if;
   end Append_Tab;


end Xm_Utilities.Xm_Strings;
